#!/bin/bash
if [ "$(id -u)" != "0" ]; then
echo 'This script must be run as root'
exit 1
fi
SETTINGS=~/vdimount.txt
CANONPATH=`readlink -f "$0"`
FOLDERPATH=`dirname "$CANONPATH"`
if [ -e "/media" ]; then
	mountdir=/media/vdi
	else
	mountdir=/mnt/vdi
fi
binskip=`grep -o "binskip" $SETTINGS`
if [ "$binskip" != binskip ]; then
	if [ "$FOLDERPATH" != /usr/bin ]; then
		echo "Install Script as Command(/usr/bin)? [Y/n]"
		read bininstall
		if [ "$bininstall" = Y ]; then
			echo binskip >> $SETTINGS
			sudo cp "$CANONPATH" /usr/bin/vdimount
			chmod +rx /usr/bin/vdimount
			echo "Script Installed to /usr/bin as 'vdimount'"
			echo "Restart Terminal for Changes to Take Effect"
			exit 1
		fi
	fi
	echo binskip >> $SETTINGS
fi
checknbd=`dpkg-query -W -f='${Status}' qemu-kvm`
if [ "$checknbd" != "install ok installed" ]; then
	echo "Missing Deppendencies!"
	echo "Install them?[Y/n]"
	read installnbd
	if [ $installnbd = Y ]; then
		sudo apt-get install qemu-kvm
		echo "Dependencies Installed!!"
	else
		echo "Script can't run without them!"
		exit 1
	fi
fi
echo "VDI MOUNTER"
echo "******************"
echo "What to do?"
echo "1: Mount VDI"
echo "2: Unmount VDI"
echo "3: Check VDI Mount"
echo "rs: Clear Settings File"
read userselect

if [ "$userselect" = 1 ]; then
	if mountpoint -q "$mountdir"; then
		echo "VDI Already Mounted! Unmount it First before Mounting Again!"
		exit 1
	fi
		echo "Enter VDI Location:(Full Path or Drag-and-Drop)";
		read VDI
		sudo qemu-nbd -c /dev/nbd0 $VDI
		sudo sfdisk -luM /dev/nbd0
		echo "**********************************************"
		echo "Enter Partition to be Mounted [ex:/dev/nbd0p1]"
		read device
		if [ ! -e "$mountdir" ]; then
			mkdir $mountdir
		fi
		mount $device $mountdir
		echo "**********************************************"
		echo "$VDI Mounted to "$mountdir""
		exit 1
fi
if [ "$userselect" = 2 ]; then
	if mountpoint -q "$mountdir"; then
		umount $mountdir
		qemu-nbd -d /dev/nbd0
		echo "**********************************************"
		echo "VDI Unmounted"
		exit 1
	else
		echo "No VDI Mounted!"
		exit 1
	fi
fi
if [ "$userselect" = 3 ]; then
	if mount | grep -q "/dev/nbd0"; then
		echo "A VDI is Mounted!"
		highlight=`mount | grep "/dev/nbd0"`
		echo "$highlight"
		exit 1
	else
		echo "No VDI Mounted!"
		exit 1
	fi
fi
if [ "$userselect" = rs ]; then
	rm ~/vdimount.txt
	echo "Settings File Cleared!"
fi

